Exec { timeout => 300 }


class {'cinder':
    rabbit_host      => "10.35.2.63",
    rabbit_port      => '5672',
    rabbit_userid    => 'guest',
    rabbit_password  => 'guest',
    sql_connection   => "mysql://cinder:0b9bc9ac6ba94f4a@192.168.0.24/cinder",
    verbose          => true,
    debug            => false,
    mysql_module   => '2.2',
}
cinder_config {
  "DEFAULT/glance_host": value => "10.35.2.63";
}

package {'python-keystone':
  notify => Class['cinder::api'],
}

class {'cinder::api':
  keystone_password => '7c747397edba4758',
  keystone_tenant => "services",
  keystone_user => "cinder",
  keystone_auth_host => "10.35.2.63",
}

class {'cinder::scheduler':
}

class {'cinder::volume':
}

class {'cinder::client':
}

# Cinder::Type requires keystone credentials
Cinder::Type {
  os_password     => '7c747397edba4758',
  os_tenant_name  => "services",
  os_username     => "cinder",
  os_auth_url     => "http://10.35.2.63:5000/v2.0/",
}

class { 'cinder::backends':
  enabled_backends => ['lvm'],
}
class { 'cinder::setup_test_volume':
  size => '20G',
  loopback_device => '/dev/loop2',
  volume_path => '/var/lib/cinder',
  volume_name => 'cinder-volumes',
}

# Add loop device on boot
$el_releases = ["RedHat", "CentOS", "Scientific"]
if $::operatingsystem in $el_releases and $::operatingsystemmajrelease < 7 {

  file_line{ 'rc.local_losetup_cinder_volume':
    path  => '/etc/rc.d/rc.local',
    match => '^.*/var/lib/cinder/cinder-volumes.*$',
    line  => 'losetup -f /var/lib/cinder/cinder-volumes && service openstack-cinder-volume restart',
  }

  file { '/etc/rc.d/rc.local':
    mode  => '0755',
  }

} else {

  file { 'openstack-losetup':
    path    => '/usr/lib/systemd/system/openstack-losetup.service',
    before  => Service['openstack-losetup'],
    notify  => Exec['/usr/bin/systemctl daemon-reload'],
    content => '[Unit]
Description=Setup cinder-volume loop device
DefaultDependencies=false
Before=openstack-cinder-volume.service
After=local-fs.target

[Service]
Type=oneshot
ExecStart=/usr/bin/sh -c \'/usr/sbin/losetup -j /var/lib/cinder/cinder-volumes | /usr/bin/grep /var/lib/cinder/cinder-volumes || /usr/sbin/losetup -f /var/lib/cinder/cinder-volumes\'
ExecStop=/usr/bin/sh -c \'/usr/sbin/losetup -j /var/lib/cinder/cinder-volumes | /usr/bin/cut -d : -f 1 | /usr/bin/xargs /usr/sbin/losetup -d\'
TimeoutSec=60
RemainAfterExit=yes

[Install]
RequiredBy=openstack-cinder-volume.service',
  }

  exec { '/usr/bin/systemctl daemon-reload':
    refreshonly => true,
    before => Service['openstack-losetup'],
  }

  service { 'openstack-losetup':
    ensure => running,
    enable => true,
    require => Class['cinder::setup_test_volume'],
  }

}

file_line { 'snapshot_autoextend_threshold':
  path    => '/etc/lvm/lvm.conf',
  match   => '^ *snapshot_autoextend_threshold +=.*',
  line    => '   snapshot_autoextend_threshold = 80',
  require => Package['lvm2'],
}

file_line { 'snapshot_autoextend_percent':
  path    => '/etc/lvm/lvm.conf',
  match   => '^ *snapshot_autoextend_percent +=.*',
  line    => '   snapshot_autoextend_percent = 20',
  require => Package['lvm2'],
}

cinder::backend::iscsi { 'lvm':
  iscsi_ip_address => '10.35.2.63',
  require => Package['lvm2'],
}

cinder::type { 'iscsi':
  set_key   => 'volume_backend_name',
  set_value => 'lvm',
  require   => Class['cinder::api'],
}
class { 'cinder::backup':
}

class { 'cinder::backup::swift':
  backup_swift_url => 'http://10.35.2.63:8080/v1/AUTH_'
}

Class['cinder::api'] ~> Service['cinder-backup']
# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'cinder_10.35.2.63':
  host => '10.35.2.63',
  service_name => 'cinder',
  chain => 'INPUT',
  ports => ['3260'],
  proto => 'tcp',
}
# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'cinder_API':
  host => 'ALL',
  service_name => 'cinder-api',
  chain => 'INPUT',
  ports => ['8776'],
  proto => 'tcp',
}
