Exec { timeout => 300 }

$keystone_use_ssl = false

class {"keystone":
    admin_token => "80d8a61c9bbe4bebbc045bb7fbdaef46",
    sql_connection => "mysql://keystone_admin:e912d0bd348d4f88@192.168.0.24/keystone",
    token_format => "UUID",
    verbose => true,
    debug => false,
    mysql_module => '2.2',
    service_name => 'keystone',
    enable_ssl => $keystone_use_ssl,
}

if 'keystone' == 'httpd' {
  include packstack::apache_common
  class {"keystone::wsgi::apache":
    ssl => $keystone_use_ssl,
  }
}

class {"keystone::roles::admin":
    email => "root@localhost",
    password => "redhat",
    admin_tenant => "admin"
}

class {"keystone::endpoint":
    region => "RegionOne",
    public_address  => "10.35.2.63",
    admin_address  => "10.35.2.63",
    internal_address  => "10.35.2.63",
}

# Run token flush every minute (without output so we won't spam admins)
cron { 'token-flush':
    ensure => 'present',
    command => '/usr/bin/keystone-manage token_flush >/dev/null 2>&1',
    minute => '*/1',
    user => 'keystone',
    require => [User['keystone'], Group['keystone']],
} -> service { 'crond':
    ensure => 'running',
    enable => true,
}
# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'keystone':
  host => 'ALL',
  service_name => 'keystone',
  chain => 'INPUT',
  ports => ['5000', '35357'],
  proto => 'tcp',
}


class {"glance::keystone::auth":
    region => "RegionOne",
    password => "d013b41dbc574064",
    public_address => "10.35.2.63",
    admin_address => "10.35.2.63",
    internal_address => "10.35.2.63",
}


class {"cinder::keystone::auth":
    region           => "RegionOne",
    password         => "7c747397edba4758",
    public_address   => "10.35.2.63",
    admin_address    => "10.35.2.63",
    internal_address => "10.35.2.63",
}



class {"nova::keystone::auth":
    region => "RegionOne",
    password    => "eb4ac94ee6df45be",
    public_address => "10.35.2.63",
    admin_address => "10.35.2.63",
    internal_address => "10.35.2.63",
    cinder => true,
}


class {"neutron::keystone::auth":
    region => "RegionOne",
    password    => "7d7e1a902aa64ad0",
    public_address => "10.35.2.63",
    admin_address => "10.35.2.63",
    internal_address => "10.35.2.63",
}

class { 'swift::keystone::auth':
  public_address  => '10.35.2.63',
  region => 'RegionOne',
  password => '89f7a735f7a546a6',
}
