Exec { timeout => 300 }


class { 'swift::ringbuilder':
  part_power     => '18',
  replicas       => '1',
  min_part_hours => 1,
  require        => Class['swift'],
}

# sets up an rsync db that can be used to sync the ring DB
class { 'swift::ringserver':
  local_net_ip => "10.35.2.63",
}

if ($::selinux != "false"){
    selboolean{'rsync_export_all_ro':
        value => on,
        persistent => true,
    }
}

@@ring_object_device { "10.35.2.63:6000/swiftloopback":
  zone   => 1,
  weight => 10, }

@@ring_container_device { "10.35.2.63:6001/swiftloopback":
  zone   => 1,
  weight => 10, }

@@ring_account_device { "10.35.2.63:6002/swiftloopback":
  zone   => 1,
  weight => 10, }


class { 'ssh::server::install': }

Class['swift'] -> Service <| |>
class { 'swift':
    # not sure how I want to deal with this shared secret
    swift_hash_suffix => '3ad73fd3add54877',
    package_ensure    => latest,
}
