Exec { timeout => 300 }


# Package mariadb-server conflicts with mariadb-galera-server
package {"mariadb-server":
    ensure => absent,
}

class {"mysql::server":
    package_name     => "mariadb-galera-server",
    restart          => true,
    root_password    => "4e3853bb25824ac4",
    require          => Package['mariadb-server'],
    override_options => {
      'mysqld' => { bind_address => "0.0.0.0",
                    default_storage_engine => "InnoDB",
                    max_connections => "1024",
                    open_files_limit => '-1',
      }
    }
}

# deleting database users for security
# this is done in mysql::server::account_security but has problems
# when there is no fqdn, so we're defining a slightly different one here
database_user { [ 'root@127.0.0.1', 'root@::1', '@localhost', '@%' ]:
    ensure  => 'absent', require => Class['mysql::server'],
}
if ($::fqdn != "" and $::fqdn != "localhost") {
    database_user { [ "root@${::fqdn}", "@${::fqdn}"]:
        ensure  => 'absent', require => Class['mysql::server'],
    }
}
if ($::fqdn != $::hostname and $::hostname != "localhost") {
    database_user { ["root@${::hostname}", "@${::hostname}"]:
        ensure  => 'absent', require => Class['mysql::server'],
    }
}

class {"keystone::db::mysql":
    user          => 'keystone_admin',
    password      => "e912d0bd348d4f88",
    allowed_hosts => "%",
    charset       => "utf8",
    mysql_module  => '2.2',
}

class {"nova::db::mysql":
  password      => "7bfe7140602749da",
  host          => "%",
  allowed_hosts => "%",
  charset       => "utf8",
  mysql_module  => '2.2',
}

class {"cinder::db::mysql":
  password      => "0b9bc9ac6ba94f4a",
  host          => "%",
  allowed_hosts => "%",
  charset       => "utf8",
  mysql_module  => '2.2',
}

class {"glance::db::mysql":
  password      => "3d2296cfef274589",
  host          => "%",
  allowed_hosts => "%",
  charset       => "utf8",
  mysql_module  => '2.2',
}

class {"neutron::db::mysql":
  password      => "d3535491e28848a4",
  host          => "%",
  allowed_hosts => "%",
  dbname        => 'neutron',
  charset       => "utf8",
  mysql_module  => '2.2',
}

# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'mariadb_10.35.2.63':
  host => '10.35.2.63',
  service_name => 'mariadb',
  chain => 'INPUT',
  ports => '3306',
  proto => 'tcp',
}

# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'mariadb_192.168.0.24':
  host => '192.168.0.24',
  service_name => 'mariadb',
  chain => 'INPUT',
  ports => '3306',
  proto => 'tcp',
}
